#!/bin/sh

if [ $# -eq 1 ]
then
	set -- $1
fi

# Config directory
CONFIG_DIR=`dirname $0`

# Current cluster
CLUSTER=$1 
shift

# Number of computers to run test
COMPUTERS=$1
shift

# 'testruns' directory
TESTRUNS_DIR=$1
shift

# ID of the current test run
TESTRUN=$1
shift

# Topology generator
TOPOLOGY=$1
shift

# Test name
TESTNAME=$1
shift

# ID of previous test run 
PREVTESTRUN=$1
shift

# Test parameters
TESTPARAMS=$@

echo STARTALL CONFIG_DIR=$CONFIG_DIR CLUSTER=$CLUSTER COMPUTERS=$COMPUTERS TESTRUNS_DIR=$TESTRUNS_DIR TESTRUN=$TESTRUN TOPOLOGY=$TOPOLOGY TESTNAME=$TESTNAME PREVTESTRUN=$PREVTESTRUN TESTPARAMS=$TESTPARAMS

##############################################################################
# creating directories
##############################################################################

mkdir -p $TESTRUNS_DIR/$TESTRUN

##############################################################################
# getting available nodes 
# result: $TESTRUNS_DIR/$TESTRUN/nodes.cfg
##############################################################################

. $CONFIG_DIR/clusters/$CLUSTER/nodes.sh

##############################################################################
# generating topology
# result: $TESTRUNS_DIR/$TESTRUN/links.cfg
##############################################################################

#TODO: change $COMPUTERS to actual number of computers ($COMPUTERS may be 'all')
. $CONFIG_DIR/links/$TOPOLOGY/makelinks.sh

##############################################################################
# copy test resources
##############################################################################

NCMD="$CONFIG_DIR/clusters/$CLUSTER/copy.sh $TESTRUNS_DIR $TESTRUN $TESTNAME $TESTPARAMS"
. $CONFIG_DIR/all.sh

##############################################################################
# start test
##############################################################################

NCMD="$CONFIG_DIR/clusters/$CLUSTER/start.sh $TESTRUNS_DIR $TESTRUN $TESTNAME $TESTPARAMS"
. $CONFIG_DIR/all.sh

echo STARTALL END
